#Bombers.py
#See http://www.mrexcessive.net/games
#
try:
   import os,sys,getopt
   import random
   import math
   import copy
   import pygame, pygame.font, pygame.mixer, pygame.image, pygame.transform
   import pygame.sprite
   from pygame.locals import *
   sys.path.append('../')
   import gamebox
   from gamebox.miniconsole import MiniConsole
   from gamebox.highscores import HighScores
except ImportError, err:
   print "couldn't load module. %s" % (err)
   sys.exit(2)

#YYY = explain. ZZZ = todo. XXX = bad thing to remove/replace, QQQ = questions to answer

#ZZZ MrExcessive branding

#YYY =====================
#Bombers
#Alien ships fly about in formations, sub-formations
#They bomb with various kinds of sticky stuff. If you get stuck you get energy drain then blow up.
#You have a laser base and shoot at them
#Update rejecting rects errors to go
#YYY =====================

#ZZZ Show how many bases left
#ZZZ Way to earn more bases
#ZZZ Random levels
#ZZZ new gun should fade in from 50%, 2 seconds noise, invulnerable and moveable (so can avoid immediate trouble)
#ZZZ Silver regroup function (new movement pattern:lattice, has specific positions) on random chance (3% or something - initiate regroup, so once every 30 seconds ?)
#ZZZ Various types of sticky stuff

#ZZZ highscores enhancements
#ZZZ customisations galore
#ZZZ website configurator for customisations
#ZZZ custom customisor for our customers, so they can say 'Hi there Sammy' or whatever
#ZZZ package protection vs. viruses (checksum self and refuse to run), put into bombers2exe code.

#ZZZ for the gamesconsole app: PG 25jan02
#scores: high, low, rank, accolades, shared accolades (jack of all trades)
#persist:save game state, load game state
#
#network: chat, find nodes, host gameroom (not single game - no central connection necessary after this point), spy gameroom (audience!?)
#+persist: save/load game state / characters
#+chat: exchange backgrounds, games
#+distro: install games, get versions, maintain separation
#

#CUSTOMISATIONS
cust_name = 'Fletcher Swan Test Ltd'
cust_salescontact = 'Steve James'
cust_salesemail = 'steve.james_fletcher_swan@mrexcessive.net'
cust_salesphone = '01234 567 8901'
#ZZZ upload highscores and central table

#GAME CONTROL
addanotherball = 0
gravity = .05        # accel due to gravity
score = 0
things_to_do = []
walkpattern_circle = []
walkpattern_invaders = []        #L->R down slowly, R->L down slowly &c.
pattern_init = { 10 : 150, 11 : 40, 20 : 150 }        # CHANGE NUMBER OF STEPS FROM HERE
silent = 0     # allow sounds
OPTIONS = {}

lostsprites = []
deadgunsprites = []
gunsprites = []

#preloaded images and sounds
preload_bullet_image = ''
preload_bomb_image = ''
preload_bomb_dead_image = ''
preload_bomb_diag_image = ''
preload_bomb_diag_dead_image = ''
preload_small_plane_image = ''
preload_plane_image = ''
preload_plane_exploded_image = ''
missile_sound = ''
explode_sound = ''
explode_quiet_sound = ''
gun_explode_sound = ''
wierd_sound = ''
uplevel_hurrah_sound = ''
bombdrop_sound = ''
bombdrop_diag_sound = ''


#game global options, controlled by command line
def usage():
   print "Usage:"
   print "python bombers.py [-F]"
   print "   -f   =   Fullscreen mode"
   print "   -h   =   Print usage information"
   print "   -x   =   Run mygamebox at end and update scores" #ZZZ integrate hiscores
   print

def setup_walkpatterns():
   global pattern_init
   #CIRCLE
   steps = pattern_init[10]
   rotate = 10 * math.pi    # 5 circles, well 2 circles and then spirals in and out
   justcirclestill = 2 * (steps / 10)
   rotstep = rotate / steps
   startradius = 100
   radius = startradius
   radiusreduce =  (startradius  * 2.0) /  (7 * (steps / 10)) # *2 so gets back out -ve at end
   angle = math.pi / 2   # start at top
   valx,valy = (0,startradius)
   wp_circle = []
   for i in range(steps):
      if i >= justcirclestill:
         radius -= radiusreduce
         #ZZZ consider changing angle ? (add another couple of rotsteps ?)
      nx = radius * math.cos(angle)
      ny = radius * math.sin(angle)
      dx = valx - nx
      dy = valy - ny
      valx = nx
      valy = ny
      wp_circle.append((dx,dy))
      #print int(dx),int(dy)," : ",int(nx),int(ny)
      angle += rotstep
   global walkpattern_circle
   walkpattern_circle = wp_circle
   #INVADERS
   steps = pattern_init[20]
   sd2 = steps / 2
   sdsmall = steps / 10
   inv_dx = 9
   inv_dy = 3
   wp_invaders = []
   wp_invaders[0:sd2] = [(-inv_dx,0)] * sd2
   wp_invaders[sd2:steps-1] = [(inv_dx,0)] * sd2
   wp_invaders[sd2-sdsmall:sd2] = [(0,inv_dy)] * sdsmall
   wp_invaders[steps-sdsmall:steps-1] = [(0,inv_dy)] * sdsmall
   global walkpattern_invaders
   walkpattern_invaders = wp_invaders

def load_image(name, colorkey=None):
   fullname = os.path.join('data',name)
   try:
      image = pygame.image.load(fullname) #QQQ Does pygame.image.load() cache things?
   except pygame.error, message:
      print 'Cannot load image:', name
      raise SystemExit, message
   image = image.convert()
   if colorkey is not None:
      if colorkey is -1:
         colorkey = image.get_at((0,0))
      image.set_colorkey(colorkey, RLEACCEL)
   return image, image.get_rect()
   
def load_sound(name):
   if not pygame.mixer:
      return NoSound()
   fullname = os.path.join('data',name)
   try:
      sound = pygame.mixer.Sound(fullname)
   except pygame.error, message:
      print 'Cannot load sound:', name
      raise SystemExit, message
   return sound

def load_music(name):
   if not pygame.mixer.music:
      return NoneSound()
   fullname = os.path.join('data',name)
   try:
      music = pygame.mixer.Sound(fullname)   #QQQ Should be using .mixer.music
      #ZZZ music = pygame.mixer.music.load(name)
      #ZZZ music.set_endevent() # ZZZ get it to loop... need to define an pygame.event subclass I think/  USEREVENT
   except pygame.error, message:
      print 'Cannot load music:', name
      raise SystemExit, message
   return music


def set_level_background(level,dolabel = 1):
   fnames = ['weather.jpg','nightsky.jpg','nebulae.jpg','neon.jpg']
   fnames += ['reddy.jpg','helix.jpg','planet.jpg','sombrero.jpg']
   fnames += ['highscore.jpg']
   fname = fnames[(level-1) % len(fnames)]
   bgimage,bgrect = load_image(fname,None)
   bgimage = bgimage.convert()
   bgimage.set_alpha(192)        # slightly faded
   background = pygame.Surface(screen.get_size())
   background.blit(bgimage,(0,0))
   if dolabel:
      font = pygame.font.Font("kitchen.ttf",36)
      text = font.render("LEVEL " + str(level), 1, (235,220,255))
      textpos = text.get_rect()
      textpos.centerx = background.get_rect().centerx
      background.blit(text,textpos)
   return background


class Gun(pygame.sprite.Sprite):
   """moves gun turret, following key commands"""
   def __init__(self):
      pygame.sprite.Sprite.__init__(self)    #call Sprite initialiser
      self.image, self.rect = preload_plane_image
      screen = pygame.display.get_surface()
      self.area = screen.get_rect()
      self.thingnumber = -10     # it just is, ok ! yes I'm sure it can be done better... TMH please
      self.gunshot_wound = 0
      self.reinit()

   def reinit(self):
      self.rect.midbottom = self.area.midbottom
      self.rect = self.rect.move(200,-30)         # up a bit # ZZZ position subguns properly. safeish but not useful startpos
      self.movepos = 0
      self.basespeed = 6
      self.diein = 0
      self.gunarea = self.area      # gunarea setting in here... probably depends on gun type(subclass) actually... but here's a note anyway
      self.gunarea.topleft = (self.gunarea[0],int(self.gunarea.height * 0.75))
      self.gunarea.height = int(self.gunarea.height * 0.35)     # gun can move in bottom 35% of screen

   def moveleft(self,faster = 1):
      self.movepos -= self.basespeed * faster
      
   def moveright(self,faster = 1):
      self.movepos += self.basespeed * faster
   
   def set_dying(self):
      if self.diein == 0:
         self.basespeed = 3      # will it get away
         self.diein = 50         # 2 seconds or so (24 fps). er no.
         deadgunsprites.add(self)
         gunsprites.remove(self)
   
   def update(self):
      "move gun as required by currently held down keys"
      if self.diein == 0:
         newpos = self.rect.move(self.movepos,0)
         self.movepos = 0
         if self.gunarea.contains(newpos):
            self.rect = newpos
      else:    # die if necessary
         self.diein -= 1
         if self.diein == 0:
            self.diein = -1  # really dead
            self.kill()
            lostsprites.add([self])
            #ZZZ for now, wipe out almost all score
         elif self.diein > 0:
            rotate = pygame.transform.rotate
            self.prerotate_image.lock()      # until pygame.transform.rotate code fixed
            self.image = rotate(self.prerotate_image,15 * self.diein)
            self.prerotate_image.unlock()
            self.dying_alpha -= self.fadealpha
            self.image.set_alpha(self.dying_alpha)
            
   def canshoot(self):
      if self.diein == 0:
         return 1
      else:
         return 0 # can shoot
   
   def whathitme(self,bomblist):
      "have I hit a bomb (flying or exploded)"
      hitbox = self.rect.inflate(-15, -15)      # not too sensitive. maybe vary depending on weapon (or just have really big graphics !)
      checkrects = [bomb.rect for bomb in bomblist]
      collidelist = hitbox.collidelistall(checkrects)
      if collidelist != []:
         whathit = [bomblist[each] for each in collidelist]
         return whathit    # everything hit, use slices[:] to get subsets if limit to weapon damage
      else:
         return []
         
   def hit(self):
      old_rect_center = self.rect.center
      self.image, self.rect = preload_plane_exploded_image
      self.prerotate_image = self.image
      self.rect.center = old_rect_center
      self.set_dying()
      self.dying_alpha = 255
      self.fadealpha = int(self.dying_alpha / self.diein)
      if not silent: gun_explode_sound.play()
         

class Bullet(pygame.sprite.Sprite):
   """creates a bullet and flies it upwards"""
   #ZZZ could have bullets which take out huge slices (powerups obviously), and multiheaded homing ones ...
   def __init__(self,whichgun):
      pygame.sprite.Sprite.__init__(self)    #call Sprite initialiser
      self.image, self.rect = preload_bullet_image
      screen = pygame.display.get_surface()
      self.area = screen.get_rect()
      self.rect.midbottom = whichgun.rect.midbottom
      self.rect = self.rect.move(0,-15)         # up a bit
      self.speed = 20
      if not silent: missile_sound.play()
      
   def update(self):
      "fly the bullet up the screen"
      pos = pygame.mouse.get_pos()
      newpos = self.rect.move(0,-self.speed)
      self.movepos = 0
      if self.area.contains(newpos):
         self.rect = newpos
      else:    # gone off screen
         self.kill()
   
class Bomb(pygame.sprite.Sprite):
   """falling bomb"""
   def __init__(self,whichsilver):
      pygame.sprite.Sprite.__init__(self)    #call Sprite initialiser
      self.image, self.rect = copy.copy(preload_bomb_image)
      self.image_dead,self.rect_dead = copy.copy(preload_bomb_dead_image)
      screen = pygame.display.get_surface()
      self.area = screen.get_rect()
      self.bombarea = Rect(self.area)
      self.bombarea.height = int(self.bombarea.height * 0.92)     # bombs explode before 100% of screen
      self.rect.midbottom = whichsilver.rect.midbottom
      self.rect = self.rect.move(0,25)         # down a bit
      self.speed = (0,12)   # slower than missiles
      self.diein = 0
      if not silent: bombdrop_sound.play()
      
   def update(self):
      "drop the bomb"
      newpos = self.rect.move(self.speed)
      if not self.diein:
         if not self.bombarea.contains(newpos):
            self.set_dying(30)
      else:
         self.diein -= 1
         if not self.diein:
            self.kill()
      if self.area.contains(newpos):
         self.rect = newpos
      else:
         self.kill()
         
   def set_dying(self,when):
      self.diein = when
      old_rect_center = self.rect.center
      self.image,self.rect = [self.image_dead,self.rect_dead]
      self.rect.center = old_rect_center
      (dx,dy) = self.speed
      self.speed = (dx / 6, dy * 1.5)     # hee hee, go sideways more... if doing it anyway
      self.start_explode()
   
   def start_explode(self):
      if not silent: explode_quiet_sound.play()
      
   def hit(self):
      "can't hit (to damage) a bomb which has already exploded - although it will wreck Bullet"
      if not self.diein:
         global score_gained
         score_gained += 5 
         self.kill()    # instant
      
      #YYY no flag set, bombs are still dangerous while exploding (often above player then fall onto)

#XXX understand whether need copy.copy !
class Bomb_Diag(Bomb):
   """bomb which falls diagonally...hehe"""
   def __init__(self,whichsilver):
      Bomb.__init__(self,whichsilver)
      self.speed = (2*(random.randint(0,11)-5),12)
      self.image,self.rect = copy.copy(preload_bomb_diag_image)
      self.image_dead,self.rect_dead = copy.copy(preload_bomb_diag_dead_image)
      self.bombarea.height = int(self.bombarea.height * 0.8)      # bombs explode way up there^
      self.rect.midbottom = whichsilver.rect.midbottom
      self.rect = self.rect.move(0,15)         # down a bit, not so far
      if not silent: bombdrop_diag_sound.play()
      
   def start_explode(self):
      if not silent: explode_sound.play()
      
   def hit(self):
      "more points"
      if not self.diein:      # can't shoot once exploded
         global score_gained
         score_gained += 20
         self.kill()
      
   
class Message(pygame.sprite.Sprite):
   """a message to user"""
   font = {}
 
   def __init__(self,msg,colour=None,fontsize=36,finaloffset = (0,0)):
      pygame.sprite.Sprite.__init__(self)
      a=1
      if not Message.font.has_key(fontsize):
         Message.font[fontsize] = pygame.font.Font("kitchen.ttf",fontsize)      # oh so big ZZZ get new free/nice ttf      
      if not colour:
         colour = ( random.randint(100,255), random.randint(100,255), random.randint(100,255) )
      text = Message.font[fontsize].render( msg, 1, colour )
      self.image = text
      self.area = screen.get_rect()       # where it is allowed to be
      self.rect = self.image.get_rect()
      self.rect.midtop = self.area.midtop
      self.finaloffset = finaloffset
      self.move = (0,+5)
      self.moving = 2
      
   def flyoff(self):
      self.move = (+3,-4)
      self.moving = 1
   
   def update(self):
      """ZZZmove and draw"""
      if self.moving:               # flying in(2) or out(1)
         newpos = self.rect.move(self.move)
         if self.moving == 1:       # out(1)
            if not self.area.colliderect(newpos):
               self.kill()
            else:
               self.rect = newpos
         elif self.moving == 2:     # gravity but no bounce score (gravity with bounce version is in gigglebubble)
            self.newmove = (self.move[0],self.move[1]+gravity*8)
            self.testarea = self.area.move(self.finaloffset)   # the bounce against floor at resting place offset
            if not self.testarea.contains(newpos):
               self.moving = 0
            else:
               self.move = self.newmove
               self.rect = newpos
            
class Silver(pygame.sprite.Sprite):
   """a stunning alien graphic (huh!?) spirals around the screen"""
   #XXX I really must load images once, just to simplify code if not speed penalty
   #ZZZ more subclasses and get subclass types right (ie. keep each one simple and not end up simulating classes with state variables)
   wingoffsets = [ (40,30),(20,10),(60,10),(30,50),(50,50) ]

   def __init__(self,imagestem,imageext,patterns,wingnumber):
      pygame.sprite.Sprite.__init__(self)    # call Sprite initialiser
      self.image_original, self.rect = load_image(imagestem + '.' + imageext, -1)
      self.hit_count = self.init_hit_count()
      self.image_explode = []
      for i in range(0,self.hit_count):
         self.image_explode.append( load_image(imagestem + '_explode' + str(i) + '.' + imageext, -1) )
      screen = pygame.display.get_surface()
      self.area = screen.get_rect()
      self.score = 150      # worth how many points
      self.fly_on = (5,1)
      self.hit_wingnumber = 20
      self.reinit(patterns,wingnumber)
      self.gunshot_wound = 0       # favourite state of affairs
      
   def init_hit_count(self):
      return 1
   
   def reinit(self,patterns,wingnumber):
      self.image = self.image_original
      self.rect = self.image.get_rect()
      self.wingnumber = wingnumber
      self.patterns = patterns      # array of patterns
      self.select_pattern(-1)        # -1 => setup and get first
      self.wingoffset = (0,0)
      self.crash_direction = ( random.randrange(-3,4),random.randrange(-25,-10) )
      self.hit_count = self.init_hit_count()
      self.bombchance = 15         # 7% chance of bomb when dropping (increase to make harder clusters of bombs)
      self.diag_bomb_chance = 5
      if wingnumber < len(Silver.wingoffsets):
         self.wingoffset = Silver.wingoffsets[wingnumber]
         self.rect = self.rect.move(self.wingoffset)
      exciting_thing = self.move()     # get first position from pattern#
      if exciting_thing != 0:    # exclude the most likely
         if exciting_thing == -1:
            self.kill()
         else:
            print "Now that is exciting, happening then of all times"
            
   def select_pattern(self,initialise = 0):
      " change to the new pattern "
      if initialise:    # reinitialise
         self.which_pattern_next = 0
      else:
         self.which_pattern_next += 1
      if self.which_pattern_next >= len(self.patterns):
         self.which_pattern_next = 0
      new_pattern = self.patterns[self.which_pattern_next]
      if new_pattern == 0:
         self.fadein = 10
      elif new_pattern in range(10,100):      # 10-99 are walkpattern_ based
         global pattern_init
         self.walking = pattern_init[new_pattern]
      self.pattern = new_pattern
      
   def update(self):
      exciting_thing = self.move()  # move and find out if something exciting happened
      if exciting_thing != 0:    # exclude the most likely
         if exciting_thing == -1:
            self.kill()
            lostsprites.add([self])
         else:
            pass
         
   def move(self):
      if self.pattern == 0:      # simple entry pattern
         newpos = self.rect.move(self.fly_on)
         if not self.area.colliderect(newpos):     # colliderect lets them slide off sides then come back on, instead of bounce against edge
            self.wingnumber = 1 - self.wingnumber
            if newpos.topleft[1] >= self.area.bottomleft[1]:      # if moved off bottom of screen
               return -1      # then kill it
         elif newpos.topleft[0] >= self.area.midtop[0]:     # if moved to middle, change pattern (ugh? this should be different)
            self.image.set_alpha(255)
            self.select_pattern()
         else:
            self.fadein += 10
            if self.fadein > 255:
               self.fadein = 255
            self.image.set_alpha(self.fadein)
            self.rect = newpos
            return 0    # not exciting
      elif self.pattern == -1:      # dying pattern
         if self.wingnumber <= 0:
            return -1    # kill it
         else:  # Shake about randomly, ignore everything (for delay as much as anything)
            self.wingnumber -= 1
            self.rect = self.rect.move( self.crash_direction )
            if self.area.colliderect(self.rect):
               self.dying_alpha -= self.fadealpha
               self.image.set_alpha(self.dying_alpha)
            else:
               return -1
      elif self.pattern in range(10,100):
         if self.walking > 0:
            self.walking -= 1
            (wm_x,wm_y) = (0,0)
            if self.pattern in range(10,20):
               global walkpattern_circle
               (wm_x,wm_y) = walkpattern_circle[self.walking]
            elif self.pattern == 20:
               global walkpattern_invaders
               (wm_x,wm_y) = walkpattern_invaders[self.walking]
            self.walkmove = (wm_x,wm_y)
            newpos = self.rect.move(self.walkmove)    # always move, even if off screen (looks better in groups)
            if not self.area.colliderect(newpos):
               return -1      # then kill it
            self.rect = newpos
         else:    # end of that walk
            self.select_pattern()
      return 0

   def hit(self):
      "decrement hitpoints, change image, blow up. Whatever is appropriate"
      if self.pattern != -1:
         self.hit_count -= 1
         if self.hit_count == 0:
            self.pattern = -1      # dying pattern
            self.gunshot_wound = -1       # Ow!
            self.wingnumber = self.hit_wingnumber     # number of steps left to live
            self.dying_alpha = 255  
            self.fadealpha = int(self.dying_alpha / self.wingnumber)
            if not silent: explode_sound.play()
            global score_gained
            score_gained += self.score
         else:
            if not silent: explode_quiet_sound.play()
         old_center = self.rect.center
         self.image,self.rect = copy.copy(self.image_explode[self.hit_count] )  # 0 is the last one used
         self.rect.center = old_center
         return 1    # absorbed bullet
      else:
         return 0    # didn't absorb bullet (may not want to let them through explosions though, or perhaps not always)

   def maybedropbombs(self):
      "maybe drop a bomb... decide here, global chance has been given"
      if random.randint(1,100) < self.bombchance:
         global level
         if self.wingnumber > 0 and level > 5:  # ZZZ normally level 5 and not solo Silver
            if 1 or random.randint(1,100) < self.diag_bombchance: #ZZZ remove the 1 or
               return [Bomb_Diag(self)]
         return [Bomb(self)]

class Silver_Frog(Silver):
   """a large frog"""
   wingoffsets = [ (120,90),(60,30),(180,30),(90,150),(150,150) ]

   def __init__(self,imagestem,imageext,patterns,wingnumber):
      Silver.__init__(self,imagestem,imageext,patterns,wingnumber)      # initialise base class
      self.score = 350      # worth how many points
      self.fly_on = (12,8)
      self.hit_wingnumber = 50
   
   def init_hit_count(self):
      return 5
   
   def reinit(self,patterns,wingnumber):
      self.image = self.image_original
      self.rect = self.image.get_rect()
      self.wingnumber = wingnumber
      self.patterns = patterns      # array of patterns
      self.select_pattern(-1)        # -1 => setup and get first
      self.wingoffset = (0,0)
      self.bombchance = 20       # 10% chance of bomb when dropping (ugh!)
      self.diag_bombchance = 3   # hardly ever (yeuch 3 of the things)
      self.hit_count = self.init_hit_count()
      self.hit_wingnumber = 50
      self.crash_direction = ( random.randrange(-3,4),random.randrange(-4,6) )
      if wingnumber < len(Silver.wingoffsets):
         self.wingoffset = Silver.wingoffsets[wingnumber]
         self.rect = self.rect.move(self.wingoffset)
      exciting_thing = self.move()     # get first position from pattern#
      if exciting_thing != 0:    # exclude the most likely
         if exciting_thing == -1:
            self.kill()
         else:
            print "Now that is exciting, happening then of all times"
      if not silent: wierd_sound.play()
            
   def maybedropbombs(self):
      if random.randrange(0,100) < self.bombchance:   # I drop 3 bombs
         dropped_bombs = [Bomb(self)]
         if (random.randrange(0,100) > 30):
            xtra_bomb = Bomb(self)
            xtra_bomb.rect = xtra_bomb.rect.move(28,3)
            dropped_bombs.append(xtra_bomb)
         if (random.randrange(0,100) > 30):
            xtra_bomb = Bomb(self)
            xtra_bomb.rect = xtra_bomb.rect.move(-28,3)
            dropped_bombs.append(xtra_bomb)
         return dropped_bombs

#Rect shrinking versions of the popular pygame Sprite module utility functions
def insensitive_spritecollide(insensitivity, sprite, group, dokill):
    """pygame.sprite.spritecollide(sprite, group, dokill) -> list
       collision detection between sprite and group
       given a sprite and a group of sprites, this will
       return a list of all the sprites that intersect.
       all sprites must have a "rect" method, which is a
       rectangle of the sprite area. if the dokill argument
       is true, the sprites that do collide will be
       automatically removed from all groups."""
    spritecollide = sprite.rect.colliderect
    crashed = []
    for s in group.sprites():
        testrect = s.rect.inflate(-insensitivity,-insensitivity)     # ZZZ is this right ?
        if spritecollide(testrect):
            if dokill: s.kill()
            crashed.append(s)
    return crashed
    
def insensitive_groupcollide(insensitivity, groupa, groupb, dokilla, dokillb):
    """pygame.sprite.groupcollide(sprite, group, dokill) -> dict
       collision detection between group and group
       given two groups, this will find the intersections
       between all sprites in each group. it returns a
       dictionary of all sprites in the first group that
       collide. the value for each item in the dictionary
       is a list of the sprites in the second group it
       collides with. the two dokill arguments control if
       the sprites from either group will be automatically
       removed from all groups."""
    crashed = {}
    for s in groupa.sprites():
        c = insensitive_spritecollide(insensitivity, s, groupb, dokillb)
        if c:
            crashed[s] = c
            if dokilla: s.kill()
    return crashed


def load_resources():
   #load images only once for sprites, perhaps load_image does cache.
   global preload_bullet_image, preload_bomb_image, preload_bomb_dead_image
   global preload_bomb_diag_image, preload_bomb_diag_dead_image
   global preload_small_plane_image,preload_plane_image,preload_plane_exploded_image
   preload_bullet_image = load_image('bullet.png', -1)
   preload_bomb_image = load_image('bomb.png',-1)
   preload_bomb_dead_image = load_image('bomb_dead.png',-1)
   preload_bomb_diag_image = load_image('bomb_diag.png',-1)
   preload_bomb_diag_dead_image = load_image('bomb_diag_dead.png',-1)
   preload_small_plane_image = load_image('plane_small.png',-1)
   preload_plane_image = load_image('plane.png',-1)
   preload_plane_exploded_image = load_image('plane_exploded.png',-1)
   global missile_sound, explode_sound, explode_quiet_sound
   global gun_explode_sound, wierd_sound, uplevel_hurrah_sound
   global bombdrop_sound, bombdrop_diag_sound
   missile_sound = load_sound('swoosh.wav');    missile_sound.set_volume(0.2)
   explode_sound = load_sound('bomb.wav');   explode_sound.set_volume(0.7)
   explode_quiet_sound = load_sound('splat.wav');   explode_quiet_sound.set_volume(0.3)
   gun_explode_sound = load_sound('implosion2.wav'); gun_explode_sound.set_volume(0.9)
   wierd_sound = load_sound('submarinealert.wav'); wierd_sound.set_volume(0.5)
   uplevel_hurrah_sound = load_sound('fanfare.wav'); uplevel_hurrah_sound.set_volume(0.6)
   bombdrop_sound = load_sound('bombdrop.wav'); bombdrop_sound.set_volume(0.1)
   bombdrop_diag_sound = load_sound('bombdrop.wav'); bombdrop_diag_sound.set_volume(0.9)
   setup_walkpatterns()


def make_silver(onething,wingcommander):
   " create and return the appropriate new Silver, Silver_Frog, whatever "
   madething = None
   if onething == 20:
      madething = Silver_Frog('silverfrogsmall','png',[20],wingcommander)
   elif onething == 1:
      madething = Silver('silversmall','png',[0,10],wingcommander)
   elif onething == 2:
      madething = Silver('silversmall','png',[0,11],wingcommander)
   elif onething == 3:
      madething = Silver('silversmall','png',[20],wingcommander)
   if madething:
      madething.thingnumber = onething
   return madething


def level(level,level_instructions,gun_lives):
  global addanotherball,score,score_gained
  global allgold,silver,background,silent,things_to_do,gun
  global lostsprites,deadgunsprites,gunsprites
  gun = Gun()
  noscore = Message("... Tally Ho ...")
  messages = []
  messages.append(noscore)
  silversprites = pygame.sprite.RenderUpdates([])
  gunsprites = pygame.sprite.RenderUpdates([gun])
  deadgunsprites = pygame.sprite.RenderUpdates([])
  bulletsprites = pygame.sprite.RenderUpdates([])
  bombsprites = pygame.sprite.RenderUpdates([])
  messagesprites = pygame.sprite.RenderUpdates(messages)
  lostsprites = pygame.sprite.RenderClear([])
  clock = pygame.time.Clock()

  background = set_level_background(level)
  screen.blit(background,(0,0))
  pygame.display.flip()
  flag_leftkeydown = 0
  flag_rightkeydown = 0
  flag_keysfaster = 1 # 2 is double speed (used for down key is speed up move)
  pause = 0
  fps = 24
  simultaneous_bullets = 4
  count_fps = fps
  things_to_do = level_instructions[:]
  while 1:
   #stop level when no new aliens coming and all wiped out
   if not things_to_do and silversprites.__len__() == 0 and lostsprites.__len__() == 0:
      return gun_lives
   count_fps -= 1
   if count_fps <= 0: # a second has passed, probably
      count_fps = fps
      if len(things_to_do):      # queue to fly in new sprites & groups, pop one thing each time
         thingstodonow = things_to_do.pop(0)
         if thingstodonow != 0:
            if type(thingstodonow) != list:      # make it a list
               thingstodonow = [thingstodonow]
            wingcommander = 0
            for onething in thingstodonow:
               silverthing = make_silver(onething,wingcommander)
               if silverthing:      # None is not useful
                  silversprites.add([silverthing])
                  wingcommander += 1
   clock.tick(fps)       # limit fps to 24 probably by end.
   if flag_leftkeydown: gun.moveleft(flag_keysfaster)
   if flag_rightkeydown: gun.moveright(flag_keysfaster)
   for event in pygame.event.get():
      if event.type is QUIT:
         return 0    # dead
      elif event.type is KEYDOWN:
         if event.key is K_ESCAPE:
            return 0       # dead ZZZ ask RUSURE?
         elif event.key == K_s:
            silent = not silent
         elif event.key == K_p:
            pause = not pause
         elif event.key == K_LEFT:
            flag_leftkeydown = 1
         elif event.key == K_RIGHT:
            flag_rightkeydown = 1
         elif event.key == K_DOWN:
            flag_keysfaster = 2.5
         elif event.key == K_SPACE:
            #bulletsprites.clear(screen,background)      # ZZZ not necessary if background replace works
            #bulletsprites.empty()      # YYY only one bullet (for now)
            if gun.canshoot() and bulletsprites.__len__() < simultaneous_bullets:     #ZZZ that is a player/level preference
               bulletsprites.add([Bullet(gun)])      # tell it which gun
      elif event.type is KEYUP:
         if event.key == K_LEFT:
            flag_leftkeydown = 0
         elif event.key == K_RIGHT:
            flag_rightkeydown = 0
         elif event.key == K_DOWN:
            flag_keysfaster = 1.5
   
   if not pause:
      #CLEAR
      bulletsprites.clear(screen,background)    #ZZZ try out background replace on changed rects instead of sprites
      gunsprites.clear(screen,background)
      deadgunsprites.clear(screen,background)
      silversprites.clear(screen,background)
      messagesprites.clear(screen,background)
      bombsprites.clear(screen,background)

      changed_rects = []      #ZZZ put in changed_rects based background replace. Then don't empty until background redrawn
      
      if count_fps == fps:    #YYY Once a second
         replacedsilvers = []
         replacedguns = []
         wingnumber = 0
         for deadthing in lostsprites.sprites():
            if deadthing.thingnumber == -10:    # Gun
               gun_lives -= 1
               if gun_lives:        # ZZZ draw small guns
                  gun = Gun()    # create, and remember - for keyboard control e.g. - a new Gun
                  replacedguns.append(gun)
               else:
                  return 0    # dead
            elif not deadthing.gunshot_wound:    #only replace ones flying off screen
               silverthing = make_silver(deadthing.thingnumber,wingnumber)
               if silverthing:      # None is not useful
                  replacedsilvers.append(silverthing)
                  wingnumber += 1
         if len(replacedsilvers):
            silversprites.add(replacedsilvers)
         if len(replacedguns):
            gunsprites.add(replacedguns)
         lostsprites.clear(screen,background)
         [sprite.kill() for sprite in lostsprites.sprites()]

      #MOVE
      messagesprites.update()
      silversprites.update()
      gunsprites.update()
      deadgunsprites.update()
      bulletsprites.update()
      bombsprites.update()

      score_gained = 0
      #BOMB
      if silversprites.__len__:     # might create new bombs if a ship is there #ZZZ different ship different chance
         if random.randrange(1,100) < 10:     # 10% chance of dropping anything (increase with level)
            allsilver = silversprites.sprites()    # this way we get clusters
            newbombs = []
            for eachsilver in allsilver:
               if eachsilver.pattern != -1:     # provided they are not 'dying' they can drop bombs
                  extrabombs = eachsilver.maybedropbombs()
                  if extrabombs:
                     newbombs += extrabombs
            if newbombs != []:
               bombsprites.add(newbombs)
      
      #did any Bullet hit any Bomb (first), then ships     # ZZZ ?move this code into Bullet, or Bomb/Silver
      hitsomething = 0
      collidedict = pygame.sprite.groupcollide(bulletsprites,bombsprites,0,0)
      if collidedict:
         for bullet in collidedict.keys():
            hits = collidedict[bullet]
            for onehit in hits:
               absorbed_bullet = onehit.hit()
               if absorbed_bullet:
                  hitsomething = 1
            if hitsomething:     #bullet vanishes #ZZZ maybe sometimes they continue ! (smaller perhaps or bigger!)
               bullet.kill()
      #did any Bullet hit any Silver
      collidedict = insensitive_groupcollide(10,bulletsprites,silversprites,0,0)
      if collidedict:
         for bullet in collidedict.keys():
            hits = collidedict[bullet]
            for onehit in hits:
               absorbed_bullet = onehit.hit()
               if absorbed_bullet:
                  hitsomething = 1
            if hitsomething:     #bullet vanishes #ZZZ maybe sometimes they continue ! (smaller perhaps or bigger!)
               bullet.kill()
      #did any Bomb hit any Gun
      collidedict = insensitive_groupcollide(25,bombsprites,gunsprites,1,0)   # auto kill the bombs
      if collidedict:
         for bomb in collidedict.keys():     # If they hit a gun then a Bomb always vanishes #ZZZ
            hits = collidedict[bomb]
            for onehit in hits:
               onehit.hit()
            bomb.kill()
   
      #SCORES
      if score_gained:
         score += score_gained
         newscore = Message("Score " + "%000d" % score)
         for message in messages:
            message.flyoff()     # ZZZ is this ok ?, maybe just score messages get flown off except level end
         messages.append(newscore)
         messagesprites.add([newscore])
         #ZZZ score points here and fly in messages, create bonuses,add extra lives, end levels &c.
         #ZZZ could do reincarations of sprites as different things

      #DRAW
      changed_rects += silversprites.draw(screen)
      changed_rects += gunsprites.draw(screen)
      changed_rects += deadgunsprites.draw(screen)
      changed_rects += bulletsprites.draw(screen)
      changed_rects += messagesprites.draw(screen)
      changed_rects += bombsprites.draw(screen)
      pygame.display.update(changed_rects)


#STARTS HERE            
   
   
def highscore(score):
   # Display highscore, get user input... can quit, play, send to a friend, check central highscore server
   background = set_level_background(9,dolabel=0)
   screen.blit(background,(0,0))
   pygame.display.flip()
   highrect = screen.get_rect()
   highs_topleft = (50,35)
   highrect.width *= 0.95
   highs_surface = pygame.Surface(highrect.size)
   highs = HighScores(highs_surface,fontsize=28,visible=1,numlines=12,topleft=highs_topleft)
   if score:
      highs.insert(score)    # allows editing
   highs.draw()
   pygame.display.flip()
   while 1:
      changed_rects = []
      for event in pygame.event.get():
         event = highs.handle(event)
         if event.type == USEREVENT:
            pass     # ZZZ user has completed name entry (could give musical crash)
         else:
            if event.type is QUIT:
               return 0       # do not play
            elif event.type is KEYDOWN:
               if event.unicode:
                  # we never know where this may blow up, so carefully does it
                  newch = ' '
                  try:
                     newch = str(event.unicode)
                  except:
                     pass
                  if newch == 'q':
                     return 0    # Don't play
                  elif newch == 'p':
                     return 1    # play
                  #ZZZ secret codes &c. to enable cheats, more bases &c.

      if highs.consolechange:
         highs.consolechange = 0  # reset bus ready

      screen.blit(background,(0,0))
      if highs.visible:
         changed_rects += [highs.draw()]
         screen.blit(highs_surface,(0,0))
      pygame.event.pump()
      pygame.display.update(changed_rects)
   

def main():
   global score
   levels = {}    # YYY so I could name them
   levels[1] = [ [1,1,1] ]
   levels[2] = [ [1,1,1],0,0,0,0,0,[3,3,3,3,3],0,[1,1,1] ]
   levels[3] = [ [3,3,3],0,0,[3,3,3],0,0,0,[3,3,3],0,0,0,0,20 ]
   levels[4] = [ [1,1,1],0,[3,3,3],1,0,3,0,1,0,3,0,[1,3,1,3,1],20 ]
   levels[5] = [ [1,1,1,1,1],0,[3,3,3,3,3],0,0,0,20,0,0,[3,3,3],0,[3,3,3],0,[3,3,3],0,[3,3,3],0,20,0,[20,20] ]
   levels[6] = [ [1,1,1,1,1],[3,3,3,3,3],0,0,0,[3,3,3],0,[3,3,3],0,[3,3,3],0,[3,3,3],0,20,0,[20,20] ]
   levels[7] = [ [1,1,1,1,1],[3,3,3,3,3],0,0,[3,3,3],0,[3,3,3],0,[3,3,3],0,[3,3,3],0,20,0,20,20,[3,3,3,3,3],20,20 ]
   levels[8] = [ [3,3,3],[3,3,3],[3,3,3],0,[3,3,3],20,20,[3,3,3],0,20,20,[3,3,3,3,3] ]
   levels[9] = [ [1,1,1,1,1],1,1,[1,1,1,1,1],[3,3,3,3,3],3,3,3,1,[1,1,1],[1,1,1],[1,1,1,1,1],0,20 ]
   levels[10] = [ [3,3,3,3,3],[1,1,1,1,1],[3,3,3,3,3],3,3,3,3,3,3,1,1,1,1,[1,1,1,1,1],20,20,20,20 ]
   flag_playgame = highscore(score)
   while flag_playgame:    # HIGH SCORE and OPTIONS PAGE, then PLAY GAME or EXIT. Repeat until done
      #PLAY GAME
      level_num = 1    # ZZZ override with password/choice ?
      gun_lives = 3
      score = 0
      while 1:
         if levels.has_key(level_num):
            playlevel = level_num
         else:
            playlevel = range(len(levels))
         gun_lives = level(level_num,levels[playlevel],gun_lives)
         if gun_lives:
            if not silent: uplevel_hurrah_sound.play()
            level_num += 1    # YYY erm, so not named...
         else:
            break
      flag_playgame = highscore(score)


def rungamebox(scoresinfo):
   os.chdir('../mygamebox')
   #ZZZ store central information and/or pass or maintain flag settings (e.g -f fullscreen)
   #ZZZ write scoresinfo to a file (use a standard module for this)
   RUN = ['python','mygamebox.py','-s','scoresfile'];
   t = open('trace','w+')
   try:
      os.execvp('python',RUN)       # this doesn't return
   except:
      print >> t, "couldn't restart gamebox", sys.exc_info()[0]
      print >> t, "suppl ", sys.exc_info()[1]
   t.close()


def play_standalone():
   global OPTIONS,screen
   OPTIONS['fullscreen'] = 0
   OPTIONS['fromgamebox'] = 0
   try:
      opts, args = getopt.getopt(sys.argv[1:], "hfx", ["help", "output=","fromgamebox"])
   except getopt.GetoptError:
      usage()
      sys.exit(2)
   for o, a in opts:
      if o in ("-h", "--help"):
         usage()
         sys.exit()
      if o == '-f':
         OPTIONS['fullscreen'] = 1
      if o == '-x':
         OPTIONS['fromgamebox'] = 1
   pygame.init()
   if OPTIONS['fullscreen']:
      screen = pygame.display.set_mode((640,480),FULLSCREEN)      # ZZZ consider 800x600 upgrade
   else:
      screen = pygame.display.set_mode((640,480))
   # We need better than 8 bit color depth
   if screen.get_bytesize() < 2:
      print "This program requires more than 256 colours."
      print "Please change your display to 16bit or 32bit colour."
      raise SystemExit
   pygame.display.set_caption('excessive B O M B E R S')
   pygame.mouse.set_visible(0)
   load_resources()
   main()
   if OPTIONS['fromgamebox']:
      print "returning to gamebox"
      rungamebox('dummyscoresinfo')


if __name__ == '__main__':
   play_standalone()
   